Index: tmp/org.txm.jodconverter.core/target/classes/document-formats.js
===================================================================
--- tmp/org.txm.jodconverter.core/target/classes/document-formats.js	(revision 0)
+++ tmp/org.txm.jodconverter.core/target/classes/document-formats.js	(revision 1230)
@@ -0,0 +1,188 @@
+[
+  {
+    "name": "Portable Document Format",
+    "extension": "pdf",
+    "mediaType": "application/pdf",
+    "storePropertiesByFamily": {
+      "DRAWING": {"FilterName": "draw_pdf_Export"},
+      "SPREADSHEET": {"FilterName": "calc_pdf_Export"},
+      "PRESENTATION": {"FilterName": "impress_pdf_Export"},
+      "TEXT": {"FilterName": "writer_pdf_Export"}
+    }
+  },
+  {
+    "name": "Macromedia Flash",
+    "extension": "swf",
+    "mediaType": "application/x-shockwave-flash",
+    "storePropertiesByFamily": {
+      "DRAWING": {"FilterName": "draw_flash_Export"},
+      "PRESENTATION": {"FilterName": "impress_flash_Export"}
+    }
+  },
+  {
+    "name": "HTML",
+    "extension": "html",
+    "mediaType": "text/html",
+    "inputFamily": "TEXT",
+    "storePropertiesByFamily": {
+      "SPREADSHEET": {"FilterName": "HTML (StarCalc)"},
+      "PRESENTATION": {"FilterName": "impress_html_Export"},
+      "TEXT": {"FilterName": "HTML (StarWriter)"}
+    }
+  },
+  {
+    "name": "OpenDocument Text",
+    "extension": "odt",
+    "mediaType": "application/vnd.oasis.opendocument.text",
+    "inputFamily": "TEXT",
+    "storePropertiesByFamily": {"TEXT": {"FilterName": "writer8"}}
+  },
+  {
+    "name": "OpenOffice.org 1.0 Text Document",
+    "extension": "sxw",
+    "mediaType": "application/vnd.sun.xml.writer",
+    "inputFamily": "TEXT",
+    "storePropertiesByFamily": {"TEXT": {"FilterName": "StarOffice XML (Writer)"}}
+  },
+  {
+    "name": "Microsoft Word",
+    "extension": "doc",
+    "mediaType": "application/msword",
+    "inputFamily": "TEXT",
+    "storePropertiesByFamily": {"TEXT": {"FilterName": "MS Word 97"}}
+  },
+  {
+    "name": "Microsoft Word 2007 XML",
+    "extension": "docx",
+    "mediaType": "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
+    "inputFamily": "TEXT"
+  },
+  {
+    "name": "Rich Text Format",
+    "extension": "rtf",
+    "mediaType": "text/rtf",
+    "inputFamily": "TEXT",
+    "storePropertiesByFamily": {"TEXT": {"FilterName": "Rich Text Format"}}
+  },
+  {
+    "name": "WordPerfect",
+    "extension": "wpd",
+    "mediaType": "application/wordperfect",
+    "inputFamily": "TEXT"
+  },
+  {
+    "name": "Plain Text",
+    "extension": "txt",
+    "mediaType": "text/plain",
+    "inputFamily": "TEXT",
+    "loadProperties": {
+      "FilterName": "Text (encoded)",
+      "FilterOptions": "utf8"
+    },
+    "storePropertiesByFamily": {"TEXT": {
+      "FilterName": "Text (encoded)",
+      "FilterOptions": "utf8"
+    }}
+  },
+  {
+    "name": "MediaWiki wikitext",
+    "extension": "wiki",
+    "mediaType": "text/x-wiki",
+    "storePropertiesByFamily": {"TEXT": {"FilterName": "MediaWiki"}}
+  },
+  {
+    "name": "OpenDocument Spreadsheet",
+    "extension": "ods",
+    "mediaType": "application/vnd.oasis.opendocument.spreadsheet",
+    "inputFamily": "SPREADSHEET",
+    "storePropertiesByFamily": {"SPREADSHEET": {"FilterName": "calc8"}}
+  },
+  {
+    "name": "OpenOffice.org 1.0 Spreadsheet",
+    "extension": "sxc",
+    "mediaType": "application/vnd.sun.xml.calc",
+    "inputFamily": "SPREADSHEET",
+    "storePropertiesByFamily": {"SPREADSHEET": {"FilterName": "StarOffice XML (Calc)"}}
+  },
+  {
+    "name": "Microsoft Excel",
+    "extension": "xls",
+    "mediaType": "application/vnd.ms-excel",
+    "inputFamily": "SPREADSHEET",
+    "storePropertiesByFamily": {"SPREADSHEET": {"FilterName": "MS Excel 97"}}
+  },
+  {
+    "name": "Microsoft Excel 2007 XML",
+    "extension": "xlsx",
+    "mediaType": "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet",
+    "inputFamily": "SPREADSHEET"
+  },
+  {
+    "name": "Comma Separated Values",
+    "extension": "csv",
+    "mediaType": "text/csv",
+    "inputFamily": "SPREADSHEET",
+    "loadProperties": {
+      "FilterName": "Text - txt - csv (StarCalc)",
+      "FilterOptions": "44,34,0"
+    },
+    "storePropertiesByFamily": {"SPREADSHEET": {
+      "FilterName": "Text - txt - csv (StarCalc)",
+      "FilterOptions": "44,34,0"
+    }}
+  },
+  {
+    "name": "Tab Separated Values",
+    "extension": "tsv",
+    "mediaType": "text/tab-separated-values",
+    "inputFamily": "SPREADSHEET",
+    "loadProperties": {
+      "FilterName": "Text - txt - csv (StarCalc)",
+      "FilterOptions": "9,34,0"
+    },
+    "storePropertiesByFamily": {"SPREADSHEET": {
+      "FilterName": "Text - txt - csv (StarCalc)",
+      "FilterOptions": "9,34,0"
+    }}
+  },
+  {
+    "name": "OpenDocument Presentation",
+    "extension": "odp",
+    "mediaType": "application/vnd.oasis.opendocument.presentation",
+    "inputFamily": "PRESENTATION",
+    "storePropertiesByFamily": {"PRESENTATION": {"FilterName": "impress8"}}
+  },
+  {
+    "name": "OpenOffice.org 1.0 Presentation",
+    "extension": "sxi",
+    "mediaType": "application/vnd.sun.xml.impress",
+    "inputFamily": "PRESENTATION",
+    "storePropertiesByFamily": {"PRESENTATION": {"FilterName": "StarOffice XML (Impress)"}}
+  },
+  {
+    "name": "Microsoft PowerPoint",
+    "extension": "ppt",
+    "mediaType": "application/vnd.ms-powerpoint",
+    "inputFamily": "PRESENTATION",
+    "storePropertiesByFamily": {"PRESENTATION": {"FilterName": "MS PowerPoint 97"}}
+  },
+  {
+    "name": "Microsoft PowerPoint 2007 XML",
+    "extension": "pptx",
+    "mediaType": "application/vnd.openxmlformats-officedocument.presentationml.presentation",
+    "inputFamily": "PRESENTATION"
+  },
+  {
+    "name": "OpenDocument Drawing",
+    "extension": "odg",
+    "mediaType": "application/vnd.oasis.opendocument.graphics",
+    "inputFamily": "DRAWING",
+    "storePropertiesByFamily": {"DRAWING": {"FilterName": "draw8"}}
+  },
+  {
+    "name": "Scalable Vector Graphics",
+    "extension": "svg",
+    "mediaType": "image/svg+xml",
+    "storePropertiesByFamily": {"DRAWING": {"FilterName": "draw_svg_Export"}}
+  }
+]

Index: tmp/org.txm.translate.rcp/src/org/txm/rcp/translate/devtools/ExportToOneFile.java
===================================================================
--- tmp/org.txm.translate.rcp/src/org/txm/rcp/translate/devtools/ExportToOneFile.java	(revision 1229)
+++ tmp/org.txm.translate.rcp/src/org/txm/rcp/translate/devtools/ExportToOneFile.java	(revision 1230)
@@ -1,16 +1,29 @@
 package org.txm.rcp.translate.devtools;
 
 import java.io.File;
+import java.io.IOException;
 import java.util.HashMap;
+import java.util.LinkedHashMap;
 import java.util.Properties;
 
 import org.txm.rcp.translate.i18n.PluginMessages;
+import org.txm.rcp.translate.i18n.WorkspaceMessagesManager;
 import org.txm.utils.BiHashMap;
+import org.txm.utils.io.IOUtils;
 
+/**
+ * Creates one properties files containing all TXM externalized and translated Strings
+ * 
+ * The keys are prefixed with the Messages.java class full path
+ * 
+ * @author mdecorde
+ *
+ */
 public class ExportToOneFile {
 
 	public static void main(String[] args) {
-		File workspace = new File("/home/mdecorde/workspace047");
+		WorkspaceMessagesManager wmm = new WorkspaceMessagesManager();
+		LinkedHashMap<File, PluginMessages> h = wmm.getPluginMessages();
 
 		HashMap<String, Properties> mergedProps = new HashMap<String, Properties>();
 		String langs[] = {"", "_fr", "_ru"};
@@ -19,44 +32,40 @@
 			mergedProps.put(lang, new Properties());
 		}
 		
-		for (File project : workspace.listFiles()) {
-			if (!project.isDirectory()) continue;
-			if (project.isHidden()) continue;
-			if (!project.getName().startsWith("org.txm")) continue;
-
-			File messagesPackageDir = new File(project, "src/"+project.getName().replaceAll("\\.", "/")+"/messages");
-			//System.out.println(messagesPackageDir.getAbsolutePath());
-
-
-
-			if (messagesPackageDir.exists()) {
-
-				for (File messagesJavaFile : messagesPackageDir.listFiles()) {
-					if (messagesJavaFile.isDirectory()) continue;
-					if (!messagesJavaFile.getName().endsWith("Messages.java")) continue;
-
-					PluginMessages messages = new PluginMessages(messagesJavaFile);
-					System.out.println(messagesJavaFile.getName()+" -> "+messages.getMessageKeys().size());
-					
-					for (String lang : langs) {
-						File propFile = messages.getFile2lang().getKey(lang);
-						if (propFile != null) {
-							BiHashMap<String, String> lmessages = messages.getLangs().get(propFile);
-							for (String key : lmessages.getKeys()) {
-								String merged_key = messagesJavaFile.getName()+"."+key;
-								if (mergedProps.get(lang).containsKey(merged_key)) {
-									System.out.println("WARNING: duplicated key ? "+merged_key);
-								} else {
-									mergedProps.get(lang).put(merged_key, lmessages.get(key));
-								}
-							}
+		
+		System.out.println("Fetching messages...");
+		for (File project : h.keySet()) {
+			
+			PluginMessages messages = h.get(project);
+			System.out.println(" "+messages.getMessageFullName()+" -> "+messages.getMessageKeys().size());
+			
+			for (String lang : langs) {
+				File propFile = messages.getFile2lang().getKey(lang);
+				if (propFile != null) {
+					BiHashMap<String, String> lmessages = messages.getLangs().get(propFile);
+					for (String key : lmessages.getKeys()) {
+						String merged_key = messages.getMessageFullName()+"."+key;
+						if (mergedProps.get(lang).containsKey(merged_key)) {
+							System.out.println(" WARNING: duplicated key ? "+merged_key);
+						} else {
+							mergedProps.get(lang).put(merged_key, lmessages.get(key));
 						}
 					}
 				}
 			}
 		}
 		
-		System.out.println(mergedProps.size());
-
+		System.out.println("Exporting messages to "+wmm.getWorkspaceLocation()+ "org.txm.translate.rcp");
+		for (String lang : langs) {
+			System.out.println(lang+" "+mergedProps.get(lang).size());
+			File mergedPropFile = new File(wmm.getWorkspaceLocation(), "org.txm.translate.rcp/messages"+lang+".properties");
+			try {
+				mergedProps.get(lang).store(IOUtils.getWriter(mergedPropFile), "compiled messages for lang="+lang);
+				System.out.println("See: "+mergedPropFile);
+			} catch (IOException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+		}
 	}
 }
Index: tmp/org.txm.translate.rcp/src/org/txm/rcp/translate/devtools/ImportFromOneFile.java
===================================================================
--- tmp/org.txm.translate.rcp/src/org/txm/rcp/translate/devtools/ImportFromOneFile.java	(revision 1229)
+++ tmp/org.txm.translate.rcp/src/org/txm/rcp/translate/devtools/ImportFromOneFile.java	(revision 1230)
@@ -1,5 +1,18 @@
 package org.txm.rcp.translate.devtools;
 
+import java.io.File;
+import java.io.FileNotFoundException;
+import java.io.IOException;
+import java.io.UnsupportedEncodingException;
+import java.util.HashMap;
+import java.util.LinkedHashMap;
+import java.util.Properties;
+
+import org.txm.rcp.translate.i18n.PluginMessages;
+import org.txm.rcp.translate.i18n.WorkspaceMessagesManager;
+import org.txm.utils.BiHashMap;
+import org.txm.utils.io.IOUtils;
+
 /**
  * 
  * @author mdecorde
@@ -9,4 +22,52 @@
  */
 public class ImportFromOneFile {
 
+	public static void main(String[] args) throws UnsupportedEncodingException, FileNotFoundException, IOException {
+
+		WorkspaceMessagesManager wmm = new WorkspaceMessagesManager();
+		LinkedHashMap<File, PluginMessages> h = wmm.getPluginMessages();
+
+		String langs[] = {"", "_fr", "_ru"};
+
+		System.out.println("Importing messages...");
+		for (String lang : langs) {
+			System.out.println(" Lang="+lang);
+
+			File mergedPropertiesFile = new File(wmm.getWorkspaceLocation(), "org.txm.translate.rcp/messages"+lang+".properties");
+			Properties mergedProperties = new Properties();
+			mergedProperties.load(IOUtils.getReader(mergedPropertiesFile));
+			String mergedLang = mergedPropertiesFile.getName().substring(8, mergedPropertiesFile.getName().length() - 11);
+			System.out.println(" MERGED LANG="+mergedLang);
+
+			if (mergedProperties.size() == 0) {
+				System.out.println(" No messages to update");
+				return;
+			}
+
+			int update = 0;
+
+			for (File project : h.keySet()) {
+
+				PluginMessages messages = h.get(project);
+
+				//messages.put(mergedLang, key, value);
+				for (String key : messages.getMessageKeys()) {
+
+					String merged_key = messages.getMessageFullName()+"."+key;
+
+					if (mergedProperties.containsKey(merged_key)) {
+						messages.put(mergedLang, key, messages.get(mergedLang, key));
+						update++;
+					}
+				}
+			}
+
+			if (update == 0) {
+				System.out.println(" Done, no update done.");
+			} else {
+				System.out.println(" Done, "+update + " update(s) done.");
+			}
+		}
+		System.out.println("Done.");
+	}
 }
Index: tmp/org.txm.translate.rcp/src/org/txm/rcp/translate/i18n/PluginMessages.groovy
===================================================================
--- tmp/org.txm.translate.rcp/src/org/txm/rcp/translate/i18n/PluginMessages.groovy	(revision 1229)
+++ tmp/org.txm.translate.rcp/src/org/txm/rcp/translate/i18n/PluginMessages.groovy	(revision 1230)
@@ -55,7 +55,32 @@
 		}
 	}
 	
-	public LinkedHashSet getMessageKeys() {
+	public void put(String lang, String key, String message) {
+		messageKeys.add(key);
+		
+		File p = new File(messageFile.getParentFile(), "messages"+lang+".properties")
+		
+		if (!langs.containsKey(p)) {
+			langs.put(p, new BiHashMap<String, String>());
+			file2lang.put(p, lang)
+		}
+		
+		if (message == null) {
+			langs.get(p).removeByKey(key);
+		} else {
+			langs.get(p).put(key, message);
+		}
+	}
+	
+	public String get(String lang, String key) {
+		File p = new File(messageFile.getParentFile(), "messages"+lang+".properties")
+		
+		if (!file2lang.containsKey(p)) return null;
+		
+		return langs.get(p).get(key);
+	}
+	
+	public LinkedHashSet<String> getMessageKeys() {
 		return messageKeys;
 	}
 	
Index: tmp/org.txm.translate.rcp/src/org/txm/rcp/translate/i18n/WorkspaceMessagesManager.java
===================================================================
--- tmp/org.txm.translate.rcp/src/org/txm/rcp/translate/i18n/WorkspaceMessagesManager.java	(revision 0)
+++ tmp/org.txm.translate.rcp/src/org/txm/rcp/translate/i18n/WorkspaceMessagesManager.java	(revision 1230)
@@ -0,0 +1,68 @@
+package org.txm.rcp.translate.i18n;
+
+import java.io.File;
+import java.util.LinkedHashMap;
+
+/**
+ * Manages the messages of the TXM projects of a RCP workspace
+ * 
+ * @author mdecorde
+ *
+ */
+public class WorkspaceMessagesManager {
+	
+	LinkedHashMap<File, PluginMessages> pluginsMessagesPerProject = new LinkedHashMap<File, PluginMessages>();
+	
+	File workspaceLocation;
+	
+	/**
+	 * Creates the manager using the "user.dir" parent directory -> works when run from Eclipse
+	 */
+	public WorkspaceMessagesManager() {
+		this(new File(System.getProperty("user.dir")).getParentFile());
+	}
+	
+	public WorkspaceMessagesManager(File workspaceLocation) {
+		this.workspaceLocation = workspaceLocation;
+		
+		if (!workspaceLocation.exists()) return;
+		if (!workspaceLocation.isDirectory()) return;
+		
+		for (File project : workspaceLocation.listFiles()) {
+			if (!project.isDirectory()) continue;
+			if (project.isHidden()) continue;
+			if (!project.getName().startsWith("org.txm")) continue;
+
+			File messagesPackageDir = new File(project, "src/"+project.getName().replaceAll("\\.", "/")+"/messages");
+			//System.out.println(messagesPackageDir.getAbsolutePath());
+
+			if (messagesPackageDir.exists()) {
+
+				for (File messagesJavaFile : messagesPackageDir.listFiles()) {
+					if (messagesJavaFile.isDirectory()) continue;
+					if (!messagesJavaFile.getName().endsWith("Messages.java")) continue;
+
+					PluginMessages messages = new PluginMessages(project, messagesJavaFile);
+					
+					pluginsMessagesPerProject.put(project, messages);
+				}
+			}
+		}
+	}
+	
+	public LinkedHashMap<File, PluginMessages> getPluginMessages() {
+		return pluginsMessagesPerProject;
+	}
+	
+	public static void main(String[] args) {
+		WorkspaceMessagesManager wmm = new WorkspaceMessagesManager();
+		LinkedHashMap<File, PluginMessages> h = wmm.getPluginMessages();
+		for (File p : h.keySet()) {
+			System.out.println(p+"="+h.get(p).getLangs().size()+" langs.");
+		}
+	}
+
+	public File getWorkspaceLocation() {
+		return workspaceLocation;
+	}
+}

